#include <gint/display.h>
#include <gint/keyboard.h>
#include <gint/timer.h>
#include <gint/clock.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#define WIDTH 396/8
#define HEIGHT 224/8
#define MAXTABLE (256*5)

static unsigned int table[MAXTABLE];

void gentable(void) {
    unsigned int i, p2;
    unsigned int minus = 800 / HEIGHT;
    if (minus == 0) minus = 1;
    for (i = 0; i < MAXTABLE; i++) {
        if (i > minus) {
            p2 = (i - minus) / 5;
            table[i] = p2;
        } else {
            table[i] = 0;
        }
    }
}

static void firemain(char *bitmap) {
    unsigned char *p;
    for (p = (unsigned char *)bitmap; p < (unsigned char *)(bitmap + WIDTH * HEIGHT); p++) {
        *p = table[(*(p + WIDTH - 1) + *(p + WIDTH + 1) + *(p + WIDTH)) + (*(p + 2 * WIDTH - 1) + *(p + 2 * WIDTH + 1))];
    }
}

static void drawfire(char *bitmap, int m1, int m2) {
    if (m1 == 0) m1 = 1;
    unsigned int last1, i1, i2;
    static unsigned int height = 0;
    register unsigned char *p;

    height++;
    i1 = 1;
    i2 = 4 * WIDTH + 1;
    for (p = (unsigned char *)bitmap + WIDTH * (HEIGHT + 0); p < (unsigned char *)bitmap + WIDTH * (HEIGHT + 1); p++, i1 += 4, i2 -= 4) {
        last1 = rand() % (i1 < i2 ? i1 : i2);
        for (; p < (unsigned char *)bitmap + WIDTH * (HEIGHT + 1); p++) {
            *p = last1;
            last1 += rand() % m1 - m2;
            *(p + WIDTH) = last1;
            last1 += rand() % m1 - m2;
            *(p + 2 * WIDTH) = last1;
            last1 += rand() % m1 - m2;
        }
    }
    firemain(bitmap);
}

#define rgb(r, g, b) ((r & 0xf8) << 8) | ((g & 0xfc) << 3) | ((b & 0xf8) >> 3)

int mod(int a, int b) {
    return (a % b + b) % b;
}

int IsKeyDownWait(int key)
{
    if (keydown(key))
    {
        while (keydown(key))
        {
            clearevents();
        }
        return 1;
    }
    return 0;
}

int main(void)
{
    char bitmap[WIDTH * HEIGHT * 2];
    int i, j;
    gentable();
    srand(time(NULL));
    char s[2] = " ";

    for (i = 0; i < HEIGHT; i++) {
        for (j = 0; j < WIDTH; j++) {
            bitmap[i * WIDTH + j] = 0;
        }
    }
    int color[4] = {
        C_WHITE,
        rgb(255, 0, 0),
        rgb(255, 255/2, 0),
        rgb(255, 255, 0)
        };
    int m1 = 8;
    int m2 = 10;
    while (!keydown(KEY_MENU)) {
        dclear(C_BLACK);
        drawfire(bitmap, m1, m2);
        if (IsKeyDownWait(KEY_UP)) {
            m1++;
        }
        if (IsKeyDownWait(KEY_DOWN)) {
            m1--;
        }
        if (IsKeyDownWait(KEY_LEFT)) {
            m2++;
        }
        if (IsKeyDownWait(KEY_RIGHT)) {
            m2--;
        }
        char nb[100];
        sprintf(nb, "%d %d", m1, m2);
        for (i = 0; i < HEIGHT; i++) {
            for (j = 0; j < WIDTH; j++) {
                int val = mod((bitmap[i * WIDTH + j] / 26), 4);
                //char c = val ? (rand() % (126 - 33)) + '~' : ' ';
                char c = " .aA"[val];
                s[0] = c;
                s[1] = 0;
                dtext(j*8, i*8, color[val], s);
            }
        }
        dtext(0, 0, C_WHITE, nb);
        dupdate();
        clearevents();
    }

    return 0;
}